# Class VulkanQueryPoolCreateInfo.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanQueryPoolCreateInfo.Builder

Enclosing class:
  `VulkanQueryPoolCreateInfo`

public static final class VulkanQueryPoolCreateInfo.Builder extends Object
Builds instances of type `VulkanQueryPoolCreateInfo`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final VulkanQueryPoolCreateInfo.Builder`
  `addAllFlags(Iterable<VulkanQueryPoolCreateFlag> elements)`
  Adds elements to `flags` set.
  `final VulkanQueryPoolCreateInfo.Builder`
  `addAllPipelineStatistics(Iterable<VulkanQueryPipelineStatisticFlag> elements)`
  Adds elements to `pipelineStatistics` set.
  `final VulkanQueryPoolCreateInfo.Builder`
  `addFlags(VulkanQueryPoolCreateFlag element)`
  Adds one element to `flags` set.
  `final VulkanQueryPoolCreateInfo.Builder`
  `addFlags(VulkanQueryPoolCreateFlag... elements)`
  Adds elements to `flags` set.
  `final VulkanQueryPoolCreateInfo.Builder`
  `addPipelineStatistics(VulkanQueryPipelineStatisticFlag element)`
  Adds one element to `pipelineStatistics` set.
  `final VulkanQueryPoolCreateInfo.Builder`
  `addPipelineStatistics(VulkanQueryPipelineStatisticFlag... elements)`
  Adds elements to `pipelineStatistics` set.
  `VulkanQueryPoolCreateInfo`
  `build()`
  Builds a new `VulkanQueryPoolCreateInfo`.
  `final VulkanQueryPoolCreateInfo.Builder`
  `from(VulkanQueryPoolCreateInfoType instance)`
  Fill a builder with attribute values from the provided `VulkanQueryPoolCreateInfoType` instance.
  `final VulkanQueryPoolCreateInfo.Builder`
  `setFlags(Iterable<VulkanQueryPoolCreateFlag> elements)`
  Sets or replaces all elements for `flags` set.
  `final VulkanQueryPoolCreateInfo.Builder`
  `setPipelineStatistics(Iterable<VulkanQueryPipelineStatisticFlag> elements)`
  Sets or replaces all elements for `pipelineStatistics` set.
  `final VulkanQueryPoolCreateInfo.Builder`
  `setQueryCount(int queryCount)`
  Initializes the value for the `queryCount` attribute.
  `final VulkanQueryPoolCreateInfo.Builder`
  `setQueryType(VulkanQueryKind queryType)`
  Initializes the value for the `queryType` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanQueryPoolCreateInfo.Builder from(VulkanQueryPoolCreateInfoType instance)
    Fill a builder with attribute values from the provided `VulkanQueryPoolCreateInfoType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values. Collection elements and entries will be added, not replaced.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanQueryPoolCreateInfo.Builder addFlags(VulkanQueryPoolCreateFlag element)
    Adds one element to `flags` set.
    Parameters:
      `element` - A flags element
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanQueryPoolCreateInfo.Builder addFlags(VulkanQueryPoolCreateFlag... elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An array of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setFlags

    public final VulkanQueryPoolCreateInfo.Builder setFlags(Iterable<VulkanQueryPoolCreateFlag> elements)
    Sets or replaces all elements for `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllFlags

    public final VulkanQueryPoolCreateInfo.Builder addAllFlags(Iterable<VulkanQueryPoolCreateFlag> elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setQueryType

    public final VulkanQueryPoolCreateInfo.Builder setQueryType(VulkanQueryKind queryType)
    Initializes the value for the `queryType` attribute.
    Parameters:
      `queryType` - The value for queryType
    Returns:
      `this` builder for use in a chained invocation

  - ### setQueryCount

    public final VulkanQueryPoolCreateInfo.Builder setQueryCount(int queryCount)
    Initializes the value for the `queryCount` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `queryCount`.

    Parameters:
      `queryCount` - The value for queryCount
    Returns:
      `this` builder for use in a chained invocation

  - ### addPipelineStatistics

    public final VulkanQueryPoolCreateInfo.Builder addPipelineStatistics(VulkanQueryPipelineStatisticFlag element)
    Adds one element to `pipelineStatistics` set.
    Parameters:
      `element` - A pipelineStatistics element
    Returns:
      `this` builder for use in a chained invocation

  - ### addPipelineStatistics

    public final VulkanQueryPoolCreateInfo.Builder addPipelineStatistics(VulkanQueryPipelineStatisticFlag... elements)
    Adds elements to `pipelineStatistics` set.
    Parameters:
      `elements` - An array of pipelineStatistics elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setPipelineStatistics

    public final VulkanQueryPoolCreateInfo.Builder setPipelineStatistics(Iterable<VulkanQueryPipelineStatisticFlag> elements)
    Sets or replaces all elements for `pipelineStatistics` set.
    Parameters:
      `elements` - An iterable of pipelineStatistics elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllPipelineStatistics

    public final VulkanQueryPoolCreateInfo.Builder addAllPipelineStatistics(Iterable<VulkanQueryPipelineStatisticFlag> elements)
    Adds elements to `pipelineStatistics` set.
    Parameters:
      `elements` - An iterable of pipelineStatistics elements
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanQueryPoolCreateInfo build()
    Builds a new `VulkanQueryPoolCreateInfo`.
    Returns:
      An immutable instance of VulkanQueryPoolCreateInfo
    Throws:
      `IllegalStateException` - if any required attributes are missing